#jinja2: lstrip_blocks: True, trim_blocks: True
# {{ ansible_managed }}

# This is the ssh server system-wide configuration file. For more information on any settings used see:
#   * ssh_config(5)
#   * https://www.ssh.com/ssh/config/

# Configuration data is parsed as follows:
#   1. command line options
#   2. user-specific file
#   3. system-wide file

# NOTE(!):
#   Any configuration value is only changed the first time it is set. Thus, host-specific definitions should be at the
#   beginning of the configuration file, and defaults at the end.

{% if openssh_server_custom_options|length > 0 %}
# Custom configuration that overwrites default configuration
# ==========================================================
{% for line in openssh_server_custom_options -%}
{{ line }}
{% endfor -%}
{% endif %}


# ===================
# Basic configuration
# ===================

# Define which port sshd should listen to. Default only to '22'.
{% for port in openssh_server_ports_list %}
Port {{ port|int }}
{% endfor %}

# Address family should always be limited to the active network configuration.
AddressFamily {{ 'any' if openssh_server_ipv6_enabled else 'inet' }}

# Define which addresses 'sshd' should listen to. Default to '0.0.0.0', ie make sure you put your desired address in
# here, since otherwise sshd will listen to everyone.
{% for address in openssh_server_listen_interfaces_list %}
ListenAddress {{ address }}
{% endfor %}

{% if _openssh_server_hostkeys_list|length > 0 %}
# List HostKeys for protocol ver.2 here
{% for key in _openssh_server_hostkeys_list %}
HostKey {{ key }}
{% endfor %}
{% endif %}

## Logging, obsoletes QuietMode and FascistLogging
SyslogFacility  {{ openssh_server_syslog_facility|upper }}
LogLevel        {{ openssl_server_loglevel|upper }}


# ======================
# Security configuration
# ======================

# Set the protocol version to 2 for security reasons. Disables legacy support.
Protocol 2

# Make sure 'sshd' checks file modes and ownership before accepting logins. This prevents accidental misconfiguration.
StrictModes yes

{% if _openssh_version is version('7.4','<') %}
# Lifetime and size of ephemeral version 1 server key
KeyRegenerationInterval 3600
ServerKeyBits           1024
{% endif %}

# ------------
# Cryptography
# ------------

{% if _openssh_server_ciphers_list|length > 0 %}
# *** Ciphers ***
# -- If your clients don't support CTR (eg older versions), cbc will be added
# CBC: is true if you want to connect with OpenSSL-base libraries
# eg ruby Net::SSH::Transport::CipherFactory requires cbc-versions of the given openssh ciphers to work
# -- see: (http://net-ssh.github.com/net-ssh/classes/Net/SSH/Transport/CipherFactory.html)
Ciphers {{ _openssh_server_ciphers_list | join(',') }}
{% endif %}

{% if _openssh_server_macs_list|length > 0 %}
# *** Hash algorithms ***
#-- Make sure not to use SHA1 for hashing, unless it is really necessary.
# Weak HMAC is sometimes required if older package versions are used
# eg Ruby's Net::SSH at around 2.2.* doesn't support sha2 for hmac, so this will have to be set true in this case.
MACs {{ _openssh_server_macs_list | join(',') }}
{% endif %}

# Alternative setting, if OpenSSH version is below v5.9
#MACs hmac-ripemd160

{% if _openssh_server_kexs_list|length > 0 %}
# *** Key Exchange Algorithms (KEX) ***
#-- Make sure not to use SHA1 for kex, unless it is really necessary
# Weak kex is sometimes required if older package versions are used
# eg ruby's Net::SSH at around 2.2.* doesn't support sha2 for kex, so this will have to be set true in this case.
# -- based on: https://bettercrypto.org/static/applied-crypto-hardening.pdf
KexAlgorithms {{ _openssh_server_kexs_list | join(',') }}
{% endif %}


# --------------
# Authentication
# --------------

# Either disable or only allow ssh root login via certificates.
PermitRootLogin {{ openssh_server_permit_root_login if openssh_server_permit_root_login|length > 0 else ('prohibit-password' if _openssh_version is version('7.6','>=') else 'no') }}

{% if _openssh_version is version('7.4','<') %}
# Secure Login directives.
UseLogin no
{% endif %}

{% if _openssh_version is version('7.5','<') %}
# Privilege Separation usually is turned on for security
UsePrivilegeSeparation {{ openssh_server_privilege_separation|string }}
{% endif %}

LoginGraceTime {{ openssh_server_login_grace_time }}
MaxAuthTries   {{ openssh_server_max_auth_retries|int }}
MaxSessions    10
MaxStartups    {{ openssh_server_max_startups }}

# Enable public key authentication
PubkeyAuthentication yes

# Never use host-based authentication. It can be exploited.
HostbasedAuthentication no
# Don't read the user's ~/.rhosts and ~/.shosts files
IgnoreRhosts            yes
{% if _openssh_version is version('7.4','<') %}
## For this to work you will also need host keys in /etc/ssh_known_hosts
RhostsRSAAuthentication no
{% endif %}
# Uncomment if you do not trust ~/.ssh/known_hosts for RhostsRSAAuthentication
IgnoreUserKnownHosts    yes

# Set this to 'yes' to enable PAM authentication, account processing, and session processing. If this is enabled, PAM
# authentication will be allowed through the ChallengeResponseAuthentication and PasswordAuthentication. Depending on
# your PAM configuration, PAM authentication via ChallengeResponseAuthentication may bypass the setting of
# "PermitRootLogin without-password". If you just want the PAM account and session checks to run without PAM
# authentication, then enable this but set PasswordAuthentication and ChallengeResponseAuthentication to 'no'.
UsePAM {{ 'yes' if openssh_server_use_pam_allowed|bool else 'no' }}

{% if openssh_server_authentication_methods|length > 0 and _openssh_version is version('6.2','>=') %}
# AuthenticationMethods was introduced in OpenSSH 6.2 - https://www.openssh.com/txt/release-6.2
# Specifies the authentication methods that must be successfully completed for a user to be granted access. This option
# must be followed by one or more lists of comma-separated authentication method names, or by the single string 'any'
# to indicate the default behaviour of accepting any single authentication method. If the default is overridden, then
# successful authentication requires completion of every method in at least one of these lists.
# For example, "publickey,password publickey,keyboard-interactive" would require the user to complete public key
# authentication, followed by either password or keyboard interactive authentication. Only methods that are next in
# one or more lists are offered at each stage, so for this example it would not be possible to attempt 'password' or
# 'keyboard-interactive' authentication before public key.
AuthenticationMethods {{ openssh_server_authentication_methods | join(',') }}
{% endif %}

# Disable password-based authentication. It can allow for potentially easier brute-force attacks.
PasswordAuthentication no
# To enable empty passwords, change to "yes" (NOT RECOMMENDED)
PermitEmptyPasswords   no

# Enable challenge-response passwords (beware issues with some PAM modules and threads)
ChallengeResponseAuthentication {{ 'yes' if openssh_server_challenge_response_auth_allowed|bool else 'no' }}

# The keyboard-interactive authentication is more complex request for arbitrary number of pieces of information.
# For each piece of information the server sends the label of the prompt. Moreover it allows the server to provide
# lenghty description of the overall "form". The server can also specify which inputs are secret (needs to be
# obfuscated when user types them) and which are not.
# Though in majority of cases the keyboard-interactive authentication is used to request a single "secret" password
# prompt, so there's hardly any difference to the password authentication.
# That's the difference from protocol perspective.
KbdInteractiveAuthentication {{ 'yes' if openssh_server_keyboard_interactive_auth_allowed|bool else 'no' }}

# Only enable Kerberos authentication if it is configured.
KerberosAuthentication {{ 'yes' if openssh_server_kerberos_auth_allowed|bool else 'no' }}
# Decide whether you want 'sshd' to fall back to ordinary password authentication if Kerberos authentication fails
KerberosOrLocalPasswd  no
KerberosTicketCleanup  yes

## Only enable GSSAPI authentication if it is configured.
GSSAPIAuthentication     {{ 'yes' if openssh_server_gssapi_auth_allowed|bool else 'no' }}
GSSAPICleanupCredentials yes

# In case you do not use PAM ('UsePAM no'), you can alternatively restrict users and groups here. For key-based
# authentication this is not necessary, since all keys must be explicitly enabled.
{% if openssh_server_deny_users|string|length > 0 %}
DenyUsers   {{ openssh_server_deny_users|string }}
{% endif %}
{% if openssh_server_allow_users|string|length > 0 %}
AllowUsers  {{ openssh_server_allow_users|string }}
{% endif %}
{% if openssh_server_deny_groups|string|length > 0 %}
DenyGroups  {{ openssh_server_deny_groups|string }}
{% endif %}
{% if openssh_server_allow_groups|string|length > 0 %}
AllowGroups {{ openssh_server_allow_groups|string }}
{% endif %}

{% if openssh_server_authorized_keys_file|string|length > 0 %}
AuthorizedKeysFile        {{ openssh_server_authorized_keys_file|string }}
{% endif %}
{% if openssh_server_authorized_keys_command|string|length > 0 %}
AuthorizedKeysCommand     {{ openssh_server_authorized_keys_command|string }}
AuthorizedKeysCommandUser {{ openssh_server_authorized_keys_command_user|string }}
{% endif %}


# -------
# Network
# -------

# Disable TCP "Keep alive" since it is spoofable. Use 'ClientAlive' messages instead, they use the encrypted channel
TCPKeepAlive no

# Manage 'ClientAlive' signals via interval and maximum count. This will periodically check up to a 'CountMax' number
# of times within 'Interval' timeframe, and abort the connection once these fail.
ClientAliveInterval {{ openssh_server_client_alive_interval|int }}
ClientAliveCountMax {{ openssh_server_client_alive_count|int }}

## Enable/disable tunneling
PermitTunnel       {{ 'yes' if openssh_server_permit_tunnel|bool else 'no' }}

## Enable/disable forwarding tcp connections, no real advantage without denied shell access
{% if _openssh_version is version('6.2', '>=') %}
AllowTcpForwarding {{ openssh_server_allow_tcp_forwarding_allowed if (openssh_server_allow_tcp_forwarding_allowed in ('yes', 'no', 'local', 'all')) else 'no' }}
{% else %}
AllowTcpForwarding {{ openssh_server_allow_tcp_forwarding_allowed if (openssh_server_allow_tcp_forwarding_allowed in ('yes', 'no')) else 'no' }}
{% endif %}

# Disable agent forwarding, since local agent could be accessed through forwarded connection, no real advantages
# without denied shell access
AllowAgentForwarding    {{ 'yes' if openssh_server_agent_forwarding_allowed|bool else 'no' }}

{% if openssh_server_gateway_ports|bool %}
## Port forwardings are forced to bind to the wildcard address
GatewayPorts yes
{% elif openssh_server_gateway_ports|string|lower == 'clientspecified' %}
## Clients allowed to specify which address to bind port forwardings to
GatewayPorts clientspecified
{% else %}
## Do not allow remote port forwardings to bind to non-loopback addresses.
GatewayPorts no
{% endif %}

# It is recommended to disable X11 forwarding, since local X11 display could be accessed through forwarded connection.
X11Forwarding    {{ 'yes' if openssh_server_x11_forwarding_allowed|bool else 'no' }}
{% if openssh_server_x11_forwarding_allowed|bool %}
X11DisplayOffset 10
{% endif %}
X11UseLocalhost  {{ 'yes' if openssh_server_x11_forwarding_allowed|bool else 'no' }}


# ==============================
# User environment configuration
# ==============================

{% if openssh_server_permit_env_vars_from_client %}
PermitUserEnvironment yes
# Allow client to pass locale environment variables
AcceptEnv LANG LC_* {{ openssh_server_accept_env_vars }}
{% else %}
PermitUserEnvironment no
{% endif %}


# ===================
# Misc. configuration
# ===================

Compression  {{ 'yes' if openssh_server_compression_enabled|bool else 'no' }}

# Look up the remote host name, defaults to false from 6.8 (See: http://www.openssh.com/txt/release-6.8)
# Also directive 'UseDNS' is not allowed within a Match block
UseDNS       {{ 'yes' if openssh_server_use_dns_allowed|bool else 'no' }}

PrintMotd    {{ 'yes' if openssh_server_print_motd|bool else 'no' }}

PrintLastLog {{ 'yes' if openssh_server_print_last_log|bool else 'no' }}

{% if openssh_server_banner_path|length > 0 %}
Banner       {{ openssh_server_banner_path }}
{% else %}
Banner       none
{% endif %}

{% if ansible_os_family|lower == 'debian' %}
DebianBanner {{ 'yes' if openssh_server_print_debian_banner|bool else 'no' }}
{% endif %}

{% if openssh_server_revoked_keys_list|length > 0 %}
# Reject keys that are explicitly blacklisted
RevokedKeys  {{ __openssh_revoked_keys_file|string }}
{% endif %}


{% if openssh_server_sftp_enabled|bool %}
# ===========================
# SFTP matching configuration
# ===========================
# Configuration, in case SFTP is used override default of no subsystems
# Subsystem sftp /opt/app/openssh5/libexec/sftp-server
{%   if openssh_server_sftp_match_condition|string|length > 0 %}
Subsystem sftp internal-sftp -l INFO -f LOCAL6 -u {{ openssh_server_sftp_umask }}
Match {{ openssh_server_sftp_match_condition|string }}
    ForceCommand internal-sftp -l INFO -f LOCAL6 -u {{ openssh_server_sftp_umask }}
{%     if openssh_server_sftp_chroot_dir|length > 0 %}
    ChrootDirectory {{ openssh_server_sftp_chroot_dir|string }}
{%     endif %}
    # Disable root login, even via certificates.
    PermitRootLogin no
    # Disable password-based authentication. It can allow for potentially easier brute-force attacks.
    PasswordAuthentication no
    # To enable empty passwords, change to "yes" (NOT RECOMMENDED)
    PermitEmptyPasswords no
    # The keyboard-interactive authentication is more complex request for arbitrary number of pieces of information.
    # For each piece of information the server sends the label of the prompt. Moreover it allows the server to provide
    # lenghty description of the overall "form". The server can also specify which inputs are secret (needs to be
    # obfuscated when user types them) and which are not.
    # Though in majority of cases the keyboard-interactive authentication is used to request a single "secret" password
    # prompt, so there's hardly any difference to the password authentication.
    # That's the difference from protocol perspective.
    KbdInteractiveAuthentication {{ 'yes' if openssh_server_keyboard_interactive_auth_allowed|bool else 'no' }}
    # Disable Kerberos authentication, even if it is configured to be enabled somewhere above.
    KerberosAuthentication no
    # Disable GSS-API authentication, even if it is configured to be enabled somewhere above.
    GSSAPIAuthentication no
    # Disable tunneling
    PermitTunnel no
    # Disable forwarding tcp connections, no real advantage without denied shell access
    AllowTcpForwarding no
    # Disable agent forwarding, since local agent could be accessed through forwarded connection, no real advantages
    # without denied shell access
    AllowAgentForwarding no
    # It is recommended to disable X11 forwarding, since local X11 display could be accessed through forwarded
    # connection.
    X11Forwarding no
{%   else %}
# Configuration, in case SFTP is used override default of no subsystems. These lines must appear at the *end* of
# sshd_config to override config above!
Subsystem sftp {{ __openssh_server_sftp_server_binary }}
{%   endif %}
{% endif %}


{% if openssh_server_match_address_list|length > 0 %}
# ========================================
# Source IP address matching configuration
# ========================================
{%   for item in openssh_server_match_address_list %}
Match Address {{ item.addr }}
{%     for rule in item['rules']|default([]) %}
    {{ rule | indent(4) }}
{%     endfor %}
{%   endfor %}
{% endif %}


{% if openssh_server_match_group_list|length > 0 %}
# ============================
# Group matching configuration
# ============================
{%   for item in openssh_server_match_group_list %}
Match Group {{ item.group }}
{%     for rule in item['rules']|default([]) %}
    {{ rule | indent(4) }}
{%     endfor %}
{%   endfor %}
{% endif %}


{% if openssh_server_match_user_list|length > 0 %}
# ===========================
# User matching configuration
# ===========================
{%   for item in openssh_server_match_user_list %}
Match User {{ item.user }}
{%     for rule in item['rules']|default([]) %}
    {{ rule | indent(4) }}
{%     endfor %}
{%   endfor %}
{% endif %}
